#include <stdlib.h>
#include "main.h"
#include "uart.h"


#define KEYPORT PORTB
#define KEYDDR  DDRB
#define KEYPIN  PINB
#define KEY0    PB0				// any input


#define LEDPORT	PORTC
#define LEDDDR	DDRC
#define	LED0	PC0


u8 getcap( void )
{
  u8 i = 16;

  KEYDDR &= ~(1<<KEY0);                     	// input
  KEYPORT |= 1<<KEY0;      			// pullup on

  if( KEYPIN & 1<<KEY0 )
    i--;
  if( KEYPIN & 1<<KEY0 )
    i--;
  if( KEYPIN & 1<<KEY0 )
    i--;
  if( KEYPIN & 1<<KEY0 )
    i--;
  if( KEYPIN & 1<<KEY0 )
    i--;
  if( KEYPIN & 1<<KEY0 )
    i--;
  if( KEYPIN & 1<<KEY0 )
    i--;
  if( KEYPIN & 1<<KEY0 )
    i--;
  if( KEYPIN & 1<<KEY0 )
    i--;
  if( KEYPIN & 1<<KEY0 )
    i--;
  if( KEYPIN & 1<<KEY0 )
    i--;
  if( KEYPIN & 1<<KEY0 )
    i--;
  if( KEYPIN & 1<<KEY0 )
    i--;
  if( KEYPIN & 1<<KEY0 )
    i--;
  if( KEYPIN & 1<<KEY0 )
    i--;
  if( KEYPIN & 1<<KEY0 )
    i--;

  KEYPORT &= ~(1<<KEY0);			// low level
  KEYDDR |= 1<<KEY0;                        	// discharge

  return i;
}


int main( void )
{
  u16 i;
  u8 s[10];

  uinit();
  uputs("Test Sensor Key:\n\r");

  for(;;){
    i = getcap();
    if( i < 7 )				// STK500 at 11MHz !
      LEDDDR &= ~(1<<LED0);
    else
      LEDDDR |= 1<<LED0;
    itoa( i, s, 10 );
    uputs( s );
    uputs( "\n\r" );
  }
}
